/*
 * uLan address server corba interface
 *
 * Author:
 *    Petr Smolik (petr.smolik@wo.cz)
 *
 */

#ifndef UL_CI_IDL
#define UL_CI_IDL

module ulci {
    	/* Types */
	typedef struct unit {
		unsigned short adr;
		unsigned long sn;
		unsigned short flags;
		string des;
	} unit_t;
	typedef sequence<unit_t> units_t;        

	/* Statistics */
	interface statistics {
	        readonly attribute string start_time;
		readonly attribute unsigned long dy_adr_asg_cnt;
	        readonly attribute string dy_adr_asg_last;
		readonly attribute unsigned long st_adr_req_cnt;
	        readonly attribute string st_adr_reg_last;
	};
    
        /* uLan server settings */
	interface settings {
		attribute unsigned short status_period;
		attribute unsigned short first_dy_adr;
		attribute unsigned short cycle_start;
		
		void add_static_unit(in unsigned short adr, in unsigned short sn);
		void remove_static_unit(in unsigned short sn);
    		units_t get_units();

		void save();
	};
};

#endif /* ULCI_IDL */

